"use strict";

var bind = function bind(v, k) {
  return k(v);
};

var findMaxHelper = function findMaxHelper(_x, _x2, _x3) {
  var _again = true;

  _function: while (_again) {
    var list = _x,
        memory = _x2,
        method = _x3;
    _again = false;

    if (list.length === 0 && !(memory != null)) {
      throw "Empty list to find max!";
    }

    if (list.length > 0) {
      _x = list.slice(1);
      _x2 = bind(list[0], function (first) {
        return memory != null ? method(memory) > method(first) ? memory : first : first;
      });
      _x3 = method;
      _again = true;
      continue _function;
    } else {
      return memory;
    }
  }
};

var manualConcat = function manualConcat(a, b) {
  return a.concat(b);
};

var flatMapHelper = function flatMapHelper(_x4, _x5, _x6, _x7) {
  var _again2 = true;

  _function2: while (_again2) {
    var list = _x4,
        index = _x5,
        method = _x6,
        results = _x7;
    _again2 = false;

    if (list.length === 0) {
      return results;
    } else {
      _x4 = list.slice(1);
      _x5 = index + 1;
      _x6 = method;
      _x7 = results.concat(method(list[0], index));
      _again2 = true;
      continue _function2;
    }
  }
};

var flatMap = function flatMap(list, method) {
  return flatMapHelper(list, 0, method, []);
};

exports.findMaxHelper = findMaxHelper;
exports.manualConcat = manualConcat;
exports.flatMap = flatMap;